<bugID>997127<Summary>Breakpoints not working when remote debugging global code</Summary><Description>Created attachment 8407480
remoteDebugReload.zip

User Agent: Mozilla/5.0 (Windows NT 6.1; WOW64; rv:29.0) Gecko/20100101 Firefox/29.0 (Beta/Release)
Build ID: 20140410150427

Steps to reproduce:

1. Start the attached xulrunner app.
  This app's main page contains the following JS code:

  console.log("1");
  console.log("2");
  Components.utils.import('resource://gre/modules/devtools/dbg-server.jsm');
  DebuggerServer.chromeWindowType = null;
  if (!DebuggerServer.initialized) {
    DebuggerServer.init();
    DebuggerServer.addBrowserActors(null);
  }
  DebuggerServer.openListener(6000);
  console.log("3");
  
  function test() {
    console.log("test/1");
    console.log("test/2");
  }

2. Use firefox's developer tools to connect to it (localhost:6000).

3. In the remote devtools UI, set a breakpoint in global JS scope, e.g. on line 'console.log("1");'.

4. Reload the page by evaluate 'location.reload()' in the web console. The breakpoint may be hit, if so, continue and reload the page again.



Actual results:

If reload the pages several times, breakpoints in global scope can't be triggerd any more, even if you remove and reset the breakpoints.

Sometimes closing the remote devtools, and reconnecting to the xulrunner app may help, but sometimes not work.


Expected results:

Breakpoints in global scope always be triggerd during a reload.</Description></bugID>